"""
Algebra ideals
"""

#*****************************************************************************
#  Copyright (C) 2005 David Kohel <kohel@maths.usyd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty 
#    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# 
#  See the GNU General Public License for more details; the full text 
#  is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************


from sage.algebras.algebra import Algebra
from sage.rings.ideal import Ideal_generic

class AlgebraIdeal(Ideal_generic):
    """
    An ideal in an algebra.
    """
    def __init__(self, A, gens = []):
        if not isinstance(A, Algebra):
            raise TypeError, "Argument A must be an algebra."
        Ideal.__init__(self, A, gens)

    def __repr__(self):
        return "Ideal on generators %s over %s"%(
            self.__gens, self.__algebra)

    def __call__(self, x):
        raise NotImplementedError
                                
    def __contains__(self, x):
        raise NotImplementedError 
            
    def algebra(self):
        return self.ring()

    def base_ring(self):
        return self.ring().__base_ring

    def gen(self,i):
        """
        The i-th generator of the algebra ideal.
        """
        n = len(self.__gens)
        if i < 0 or not i < n: 
            raise IndexError, \
                  "Argument i (= %s) must be between 0 and %s."%(i, n-1)
        return self.__gens[i]

    def ngens(self):
        """
        The number of generators of the algebra ideal.
        """
        return len(self.__ngens)

    
