"""
Algebra order ideals
"""

#*****************************************************************************
#  Copyright (C) 2005 David Kohel <kohel@maths.usyd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty 
#    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# 
#  See the GNU General Public License for more details; the full text 
#  is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

from algebra_ideal import AlgebraIdeal
from algebra_order import AlgebraOrder

class AlgebraOrderIdeal(AlgebraIdeal):
    """
    An ideal over an order in an algebra.
    """

    def __init__(self, A, gens = []):
        if not isinstance(A, AlgebraOrder):
            raise TypeError, "Argument A must be an algebra."
        AlgebraIdeal.__init__(self, A, gens)

    def ambient_algebra(self):
        """
        """
        return self.algebra().ambient_algebra()

    
class FractionalAlgebraOrderIdeal(AlgebraOrderIdeal):
    """
    A fractional ideal in an algebra order.  Should this in fact 
    inherit from AlgebraOrderIdeal or the converse?
    """
    pass


