"""
Interface to the GAP interpreter
"""

#*****************************************************************************
#       Copyright (C) 2005 William Stein <wstein@ucsd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

from expect import Expect

class GAP(Expect):
    def __init__(self, maxread=10000, script_subdirectory=""):
        Expect.__init__(self,
                        name = 'gap',
                        prompt = 'gap>',
                        command = "gap -n -b",
                        maxread = maxread,
                        script_subdirectory = script_subdirectory,
                        restart_on_ctrlc = True)

    def __call__(self, x):
        return Expect.__call__(self, x + ';')


instance = None            
def gap(x):
    """
    Send the code x to the GAP interpreter and return the output as a
    string.  
    """
    global instance
    if instance is None:
        instance = GAP(script_subdirectory='user')
    return instance.eval(x)

