"""
Interface to the gp interpreter
"""

#*****************************************************************************
#       Copyright (C) 2005 William Stein <wstein@ucsd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

from expect import Expect

class GP(Expect):
    def __init__(self, stacksize=100000000, maxread=10000, script_subdirectory=""):
        Expect.__init__(self,
                        name = 'gp',
                        prompt = '\\? ',
                        command = "gp --fast --quiet --stacksize %s"%stacksize,
                        maxread = maxread,
                        script_subdirectory = script_subdirectory,
                        restart_on_ctrlc = False)

instance = None            
def gp(x):
    """
    Send the code x to the PARI gp interpreter and return the output
    as a string.
    """
    global instance
    if instance is None:
        instance = GP(script_subdirectory='user')
    return instance.eval(x)

