"""
Interface to the magma interpreter
"""

#*****************************************************************************
#       Copyright (C) 2005 William Stein <wstein@ucsd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

from expect import Expect
PROMPT = ">>>"

class Magma(Expect):
    def __init__(self, maxread=10000, script_subdirectory=""):
        Expect.__init__(self,
                        name = "magma",
                        prompt = ">",
                        command = "magma -b",
                        maxread = maxread,
                        script_subdirectory = script_subdirectory,
                        restart_on_ctrlc = True)

    def _start(self):
        self._change_prompt('>')
        Expect._start(self)
        self('SetPrompt("%s");SetLineEditor(false);'%PROMPT)
        self._change_prompt(PROMPT)
        self.expect().expect(PROMPT)
        self.expect().expect(PROMPT)

instance = None            
def magma(x):
    """
    Send the code x to the Magma interpreter and return the output as
    a string.
    """
    global instance
    if instance is None:
        instance = Magma(script_subdirectory='user')
    return instance.eval(x+";")

